'article_tex.layoutgram'.
'article.gram'.
article.
text.
article(article) --> !.
dateoptional('[date]') --> !.
dateoptional(A) --> {write('\date{')},date(A),{write('}')},{nl}.
date('[date]'(A)) --> date(date(A)).
article(article(A,B,C,D)) --> {write('\documentstyle{article}')},{nl},{write('\author{')},authors(A),{write('}')},{nl},dateoptional(B),{write('\title{')},title(C),{write('}')},{nl},{write('\begin{document}')},{nl},content(D),{write('\end{document}')},{nl},{write('\bye')}.
authors(authors) --> !.
authorlist([A,'author+']) --> author(A),!.
authorlist([A,B,'author+']) --> author(A),{write(' \and ')},author(B).
authorlist([A|B]) --> author(A),{write(' \and ')},authorlist(B).
authors(authors(A)) --> authorlist(A).
author(author) --> !.
author(author(A)) --> {write('{\bf ')},text(A),{write('}')}.
date(date) --> !.
date(date(A)) --> {write('{\bf ')},text(A),{write('}')}.
title(title) --> !.
title(title(A)) --> {write('{\bf ')},text(A),{write('}')}.
content(content) --> !.
sectionlist([A,'section+']) --> section(A),!.
sectionlist([A,B,'section+']) --> section(A),{nl, nl},section(B).
sectionlist([A|B]) --> section(A),{nl, nl},sectionlist(B).
content(content(A,B)) --> {write('\maketitle')},{nl},abstract(A),{nl},{nl},sectionlist(B),{nl}.
abstract(abstract) --> !.
abstract(abstract(A)) --> {nl},{write('{\bf ')},text(A),{write('}')}.
section(section) --> !.
paragraphlist([A,'paragraph+']) --> paragraph(A),!.
paragraphlist([A,B,'paragraph+']) --> paragraph(A),{nl, nl},paragraph(B).
paragraphlist([A|B]) --> paragraph(A),{nl, nl},paragraphlist(B).
section(section(A,B)) --> heading(A),paragraphlist(B).
heading(heading) --> !.
heading(heading(A)) --> {write('\section{')},text(A),{write('}')}.
paragraph(paragraph) --> !.
paragraph(paragraph(A)) --> {nl},{nl},textpara(A).
paragraph(paragraph) --> !.
paragraph(paragraph(A)) --> {nl},{nl},{write('\begin{itemize}')},{nl},itemizelist(A),{nl},{write('\end{itemize}')}.
itemizelist(itemizelist) --> !.
itemizelist([A,'itemize+']) --> itemize(A),!.
itemizelist([A,B,'itemize+']) --> itemize(A),{nl},itemize(B).
itemizelist([A|B]) --> itemize(A),{nl},itemizelist(B).
itemizelist(itemizelist(A)) --> itemizelist(A).
textpara(textpara) --> !.
textpara(textpara(A)) --> text(A).
itemize(itemize) --> !.
itemize(itemize(A)) --> {write('\item ')},text(A).
text(text(A)) --> {write(A)}.
