#!/usr/local/tkX/4.0b3/bin/wish_4.0b3 -f
# ******************************************************************
# syndoc.tcl
# 
# Function:  Starts prolog-prosess by calling start_prolog in
#            syndocserver.tcl. Compiles prolog-programs.
#            Reads default values from configure file and 
#            makes main_menu. For BinProlog 5.00 version
# Date:      1.9.1995
# Author:    Paula Leinonen
# ******************************************************************

#**************************************************************************
# Global variables - declarations in file  syndocglobals.tcl  
#**************************************************************************


# ******************************************************************
# Name:     default_value
# Input:    -
# Output:   -
# Function: Initialize global variable SYNDOCHOME, directory for
#           syndoc program files.
# ******************************************************************
proc default_value {} {
    global SYNDOCHOME;      # Directory for Syndoc program files  
    set SYNDOCHOME "/appl/wrk/Syndoc/syndoc0.4.2/src"
}

# **********************************************************************
# Name:      initialize_defaults
# Input:     -
# Output:    -
# Function:  Reads default values for global variables from 
#            .syndocdefaults or .syndocsysdefaults file.
# **********************************************************************
proc initialize_defaults { } {
    global EDITORCMD
# Default paths for different types of files
    global struct grams iprogs layouts progs docs trgrams trprogs texs 
# Default extensions for different types of files
    global struct_file gram_file iprog_file layoutgram_file doc_file
    global prog_file trgram_file trprog_file tex_file prev_prog 
    
    global control_path
    global control_file
    global filts
    global filt_file
#    global filter_selected
    global index_path   
    global index_file
    global documents_selected
    global documents_matched
    
    global prevs prev_file

    global generic_mask_i_frame2
    global generic_param_i_frame2
    global generic_mask_l_frame3
    global generic_param_l_frame3
    global generic_mask_l_frame4
    global generic_param_l_frame4

    global generic_mask_o_frame3
    global generic_param_o_frame3
    global generic_mask_o_frame4
    global generic_param_o_frame4

    global generic_mask_t_frame4
    global generic_param_t_frame4
    

    global printer;	# Default printer 
    global print_cmd;	# Default printer command 
    global all;		# "All files" * 
    global dir;		# Users working directory 
    global prev_prog prev_file prevs; # Default values for preview
    global sysfile ownfile
    global params;	# List of the "keys" of the default values 
    global win w;	# Toplevel-windows
    global browse;	# Label text of the Select-button 

    foreach i $params {
	set $i "" 
    }
    if [file isfile $ownfile] {
	set file $ownfile
    } else {
	if [file isfile $sysfile] {
            set file $sysfile
	} else {
	    tk_dialog .d {} "Can't find file \"$sysfile\"" {} -1 OK
	    exit
	}
    }

    set def_file [open $file r]
    gets $def_file line
    while {![eof $def_file]} {
        if {[string compare [lindex $line 1] SYNDOCWORK] == 0} {
	    set dir [lindex $line 2]
        }  elseif {[string compare [lindex $line 1] STRUCTURE] == 0} {
		set struct [lindex $line 2]
		set struct_file [file tail $struct]
        }  elseif {[string compare [lindex $line 1] IGRAMMAR] == 0 } {
		set grams [lindex $line 2]
		set gram_file [file tail $grams]

		set generic_mask_i_frame2  $grams
		set generic_param_i_frame2 $gram_file
	
        }  elseif {[string compare [lindex $line 1] IPROGRAM] == 0 } {
		set iprogs [lindex $line 2]
		set iprog_file [file tail $iprogs]

        }  elseif {[string compare [lindex $line 1] LGRAMMAR] == 0 } {
		set layouts [lindex $line 2]
		set layoutgram_file [file tail $layouts]

		set generic_mask_l_frame3  $layouts
		set generic_param_l_frame3 $layoutgram_file
		set generic_mask_l_frame4  $layouts
		set generic_param_l_frame4 $layoutgram_file

        }  elseif {[string compare [lindex $line 1] LPROGRAM] == 0 } {
		set progs [lindex $line 2]
		set prog_file [file tail $progs]

        }  elseif {[string compare [lindex $line 1] DOCUMENT] == 0 } {
		set docs [lindex $line 2]
		set doc_file [file tail $docs]
		#
		# See: documents have full path so that they seem to be
		# pre-selected (selection fills the path normally).
		#
		set documents_selected [fullpath $docs]
		set documents_matched {[fullpath $docs]}
	}  elseif {[string compare [lindex $line 1] TGRAMMAR] == 0 } {
		set trgrams [lindex $line 2]
		set trgram_file [file tail $trgrams]

        }  elseif {[string compare [lindex $line 1] TPROGRAM] == 0 } {
		set trprogs [lindex $line 2]
		set trprog_file [file tail $trprogs]

		set generic_mask_t_frame4  $trprogs
		set generic_param_t_frame4 $trprog_file

        }  elseif {[string compare [lindex $line 1] OUTPUT] == 0 } {
		set texs [lindex $line 2]
		set tex_file [file tail $texs]

		set generic_mask_o_frame3 $texs
		set generic_param_o_frame3 $tex_file
		set generic_mask_o_frame4 $texs
		set generic_param_o_frame4 $tex_file

        }  elseif {[string compare [lindex $line 1] PRINTER] == 0 } {
		set printer [lindex $line 2]
        }  elseif {[string compare [lindex $line 1] PRINTCMD] == 0 } {
		set print_cmd [lindex $line 2]
        }  elseif {[string compare [lindex $line 1] EDITORCMD] == 0 } {
		set EDITORCMD [lindex $line 2]
        }  elseif {[string compare [lindex $line 1] PREVPROG] == 0 } {
		set prev_prog [lindex $line 2]
        }  elseif {[string compare [lindex $line 1] PREVFILE] == 0 } {
		set prevs [lindex $line 2]
		set prev_file [file tail $prevs]

        }  elseif {[string compare [lindex $line 1] CONTROL] == 0 } {
		set control_path [lindex $line 2]
		set control_file [file tail $prevs]
        }  elseif {[string compare [lindex $line 1] INDEX] == 0 } {
		set index_path [lindex $line 2]
		set index_file [file tail $index_path]
        }  elseif {[string compare [lindex $line 1] FILTER] == 0 } {
		set filts [lindex $line 2]
		set filt_file [file tail $filts]
#		set filter_selected $filts
	}
        gets $def_file line
    }
    close $def_file
    set all *
    set win .win
    set w .w
    set browse Select
} 




# ******************************************************************************
# Name:      main_menu
# Input:     -
# Output:    -
# Function:  Creates main-menu of the SYNDOC. 
# History:   29.12.1995 
#            Input and layout program generations are in comments. Programs 
#            are generated automatically in parts Write new document and
#            Layout document.
# ******************************************************************************
proc main_menu {} {
   eval destroy [winfo child .]
   wm title . "SYNDOC syntax-directed document processing system"
   wm geometry . +0+0
   frame .menu -relief raised -borderwidth 1
   message .msg -font -Adobe-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
	-relief raised -width 500 \
	-borderwidth 1 

   pack .menu -side top -fill x



# Grammars:
   menubutton .menu.grammars -text "Grammars" -menu .menu.grammars.m \
    -underline 0
   menu .menu.grammars.m

# Structure Grammar:
   .menu.grammars.m add command -label "Create/Edit Structure Grammar" \
        -command "edit_structure h.hlp" -underline 0
# Input Grammars
   .menu.grammars.m add cascade -label "Input Grammars" \
         -menu .menu.grammars.m.inputgram -underline 0
	 set c .menu.grammars.m.inputgram
	 menu $c
	 $c add command -label "Create Input Grammar" \
                        -command "create_inputgram h.hlp " \
		        -underline 0 
	 $c add command -label "Edit Input Grammar" \
                        -command "edit_inputgrammar h.hlp" -underline 0 

# Output grammars:
   .menu.grammars.m add cascade -label "Layout Grammars" \
	 -menu .menu.grammars.m.outputgram -underline 0
	 set c .menu.grammars.m.outputgram
	 menu $c
         $c add command -label "Create Layout Grammar" \
                        -command "create_layoutgram h.hlp" \
                        -underline 0 
         $c add command -label "Edit Layout Grammar" \
                        -command "edit_layoutgram h.hlp" \
                        -underline 0

# Input:
   menubutton .menu.input -text "Input" -menu .menu.input.m \
     -underline 0
   menu .menu.input.m
   .menu.input.m add command -label "Create New Document" \
      -command "new_document h.hlp" \
      -underline 0
   .menu.input.m add command -label "Open Document" \
       -command "old_document h.hlp" \
       -underline 0

# Output:
   menubutton .menu.output -text "Output" -menu .menu.output.m \
	-underline 0
   menu .menu.output.m
   .menu.output.m add command -label "Markup Document" \
	 -command "format_document h.hlp" \
	 -underline 0
   .menu.output.m add command -label "Preview Document" \
	 -command "preview_document h.hlp" \
	 -underline 8
   .menu.output.m add command -label "Print Document" \
	  -command  "print1_document h.hlp"\
          -underline 0

# Transform:
   menubutton .menu.transform -text "Transform" -menu .menu.transform.m \
	-underline 0
   menu .menu.transform.m
   .menu.transform.m add cascade -label "SDTS" \
         -menu .menu.transform.m.sdts -underline 0
         set c .menu.transform.m.sdts
	 menu $c
	 $c add command -label "Modify" \
			-command "sdts_modify sdts.hlp" \
                        -underline 0
	 $c add command -label "Compare" \
			-command "sdts_compare sdts.hlp" \
                        -underline 0
	 $c add command -label "Transform" \
			-command "sdts_transform sdts.hlp" \
                        -underline 0
   .menu.transform.m add cascade -label "Transducer" \
         -menu .menu.transform.m.transducer -underline 0
         set c .menu.transform.m.transducer
	 menu $c
	 $c add command -label "Modify" \
			-command "transducer_modify tr_modify.hlp" \
                        -underline 0
	 $c add command -label "Compare" \
			-command "transducer_compare tr_compare.hlp" \
                        -underline 0
	 $c add command -label "Transform" \
			-command "transducer_transform tr_transform.hlp" \
                        -underline 0

#	 $c add command -label "Generate" \
#			-command "sdts_generate sdts.hlp" \
#                        -underline 0
#	 $c add command -label "Generate" \
#			-command "transducer_generate tr_generate.hlp" \
#                        -underline 0
# Retrieval:
   menubutton .menu.retrieval -text "Retrieval" -menu .menu.retrieval.m \
	-underline 0
   menu .menu.retrieval.m
   .menu.retrieval.m add command -label "Retrieval" \
      -command "retrieval index.hlp"\
      -underline 0

# Control:
   menubutton .menu.control -text "Control" -menu .menu.control.m -underline 0
   menu .menu.control.m
   .menu.control.m add command -label "Defaults" \
			    -command "edit_defaults help.hlp" -underline 0
   .menu.control.m add command -label "System Commands" \
       -command "system_command h.hlp" \
	-underline 0


# Exit:
   menubutton .menu.exit -text "Exit" -menu .menu.exit.m -underline 0
   menu .menu.exit.m
   .menu.exit.m add command -label "Exit" \
			    -command "exit" -underline 0

   pack .menu.grammars .menu.input .menu.output .menu.retrieval \
        .menu.transform .menu.control .menu.exit -side left -expand yes
}
# Position a dialog box at a reasonable place on the screen.



# ************************************************************************
# Name:       main 
# Input:      -
# Output:     -
# Function:   At the beginning the program calls start_prolog-procedure
#             in file syndocserver.tcl. Compiles or consults prolog-programs.
#             (in file server.tcl. Compiles or consults prolog-programs.)
# ************************************************************************

    global SYNDOCHOME;      # Directory for Syndoc program files  
    default_value;          # Gives default value to SYNDOCHOME

# syndocglobals.tcl, contains all other global variables of SYNDOC
    source $SYNDOCHOME/syndocglobals.tcl

# syndoserver-program for tcl, starts prolog slave-process
    source $SYNDOCHOME/syndocserver.tcl
    start_prolog

# Compilation  of the prolog programs.
    set progName $SYNDOCHOME/syndocstart.pl
    p mcompile('$progName')
# Tcl/Tk script files
    
    source $SYNDOCHOME/syndocsystem.tcl
    source $SYNDOCHOME/syndocconfig.tcl
    source $SYNDOCHOME/syndocgrammars.tcl
    source $SYNDOCHOME/syndocinput.tcl
    source $SYNDOCHOME/syndoctree.tcl
    source $SYNDOCHOME/syndocoutput.tcl
    source $SYNDOCHOME/syndocretrieval.tcl
    source $SYNDOCHOME/syndocfiltertree.tcl
#               Indexing methods: syndocmakeindex.tcl
#               Matching methods: syndocmakematch.tcl 
    source $SYNDOCHOME/syndoctransform.tcl
    source $SYNDOCHOME/syndoctransform1.tcl
    source $SYNDOCHOME/syndochelp.tcl

    initialize_defaults;  # Initializes global variables

    main_menu;            # Makes main menu





