# ************************************************************************
# syndoccompare.tcl
# 
# Function:   Creates a top-level window with list of nonterms
# Date:       23.11.1995
# Author:     Paula Leinonen
#**************************************************************************
# **********************************************************************
# Name:        rule_selection 
# Input:       String String Srting String Integer
# Output:      String (selected nonterm)
# Function:    Opens top-level window with list of nonterms. Returns
#              selected nonterm.
# **********************************************************************
proc rule_selection { headC oldrC newrC nonTerms RLChar wi} {
    global rulewin;		# Name of the selection window
    global selectedRule;	# Selected nonterm (return value)

    set rulewin .rulewin
    toplevel $rulewin
    foreach i $headC {
	append head [format "%c" $i]
    }
    foreach i $oldrC {
	append oldr [format "%c" $i]
    }
    foreach i $newrC {
	append newr [format "%c" $i]
    }
    wm title $rulewin $head 

    button $rulewin.close -text "Close" -command "set selectedRule cancel"
    pack $rulewin.close -side bottom -fill x

    label $rulewin.l1 -width 20 -text "Old rule: " -anchor w
    label $rulewin.r1 -text $oldr -anchor w
    label $rulewin.l2 -width 20 -text "New rule: " -anchor w
    label $rulewin.r2 -text $newr -anchor w
    pack $rulewin.l1 $rulewin.r1 -side top -anchor w 
    pack $rulewin.l2 $rulewin.r2 -side top -anchor w

    scrollbar $rulewin.scroll -command "$rulewin.list yview"
    pack $rulewin.scroll -side right -fill y
    listbox $rulewin.list -yscroll "$rulewin.scroll set" -relief raised \
                                  -setgrid 1 -width $wi 
    pack $rulewin.list -side left -fill both -expand yes

    bind $rulewin.list <Double-Button-1> {set selectedRule [selection get]}

# Merkkijono muutetaan listaksi (koostuu "sanoista")
    set listOfRules $nonTerms
    split $listOfRules

    foreach i $listOfRules { 
        $rulewin.list insert end $i
    }

   grab $rulewin  
   focus $rulewin

   tkwait variable selectedRule
   w_select_rule $selectedRule
}

# **********************************************************************
# Name:        w_select_rule
# Input:       String (selected nonterm) 
# Output:      -
# Function:    Returns selected nonterm to the prolog.
# **********************************************************************
proc w_select_rule { selectedR } {

    global rulewin;	# Name of the selection window

    grab release $rulewin
    destroy $rulewin
    p done('$selectedR')

}

# **********************************************************************
# Name:        open_rules
# Input:       String String
# Output:      String
# Function:    Opens top-level window with list of rules. Returns
#              selected rule to calling prolog-program.
# **********************************************************************
proc open_rules {root rulesC wi} {
    global rulewin;		# Name of the selection window
    global selectedRule;	# Selected rule

    toplevel $rulewin
    foreach i $root {
	append root1 [format "%c" $i]
    }
    wm title $rulewin $root1 

    button $rulewin.close -text "Close" -command "set selectedRule cancel"
    pack $rulewin.close -side bottom -fill x

    scrollbar $rulewin.scroll -command "$rulewin.list yview"
    pack $rulewin.scroll -side right -fill y
    listbox $rulewin.list -yscroll "$rulewin.scroll set" -relief raised \
                                  -setgrid yes -width $wi
    pack $rulewin.list -side left -fill both -expand yes
    #wm minsize $rulewin 5 5

    bind $rulewin.list <Double-Button-1> {set selectedRule [selection get]}

    foreach i $rulesC {
	foreach j $i {
	     append rules [format "%c" $j]
        }
        $rulewin.list insert end [string trim $rules {}]
        set rules ""
    }

   set oldFocus [focus]
   grab $rulewin  
   focus $rulewin

   tkwait variable selectedRule
   c_select_rule $selectedRule $oldFocus
}

# **********************************************************************
# Name:        c_select_rule
# Input:       String (selected rule) 
# Output:      -
# Function:    Returns selected rule to the prolog.
# **********************************************************************
proc c_select_rule { selectedR oldF } {

    global rulewin;	# Name of the selection window

    grab release $rulewin
    destroy $rulewin
    grab current 
    p selected('$selectedR')

}


