# ******************************************************************
# syndocglobals.tcl
# 
# Function:  Contains declarations of all global variables 
# Date:      30.7.1996
# Author:    Eila Kuikka
# ******************************************************************
#   global SYNDOCHOME;      	# Directory for Syndoc program files  
				# defined in syndocserver.tcl

    global all 			# "All files" * 
    global annote		# annotations in filters
    global ask_ftitle		# title of ask_filter window

    global browse 		# label text of the Select-button 
    global BIBTEX_CMD           # directory and bibtex-command

    global control_file		# extension to control files
    global control_path		# path to control file and file name

    global dir 			# Users working directory 
    global doc_file		# extension to  document files
    global docs 		# path to document files
    global doc_file1		# name of the document file to be transformed 
    global doc_file2            # name of the transformed document file
    global doc_mask 		# path and document file default for indexing
    global documents_matched	# documents which match a filter
    global documentidxs_selected # documents selected in indexing for match
    global documents_selected	# document files selected for indexing
    global docText 		# parse tree in the text widget (in ASCII)

    global e 			# name of the window
    global EDITORCMD
#    global env          	# Array of environment variables

#   global f 			# defined in file  syndocserver.tcl
    global filt_file		# filter file selected by the user
    global filts		# path  to filter files
    global filter_mask          # directory which contains filters
    global ftype_file		# text type for a filter
    global ftypes		# list of text types of a grammar
    global filterhelp_file	# filter help file

    global filtText 		# parse tree in the text widget 
				#(in ASCII)

    global generic_mask_l_frame     	# directory and layout program mask 
    global generic_mask_l_frame3
    global generic_mask_l_frame4
    global generic_mask_o_frame     	# output program  mask
    global generic_mask_o_frame3
    global generic_mask_o_frame4
    global generic_mask_t_frame     	# directory and transform program mask
    global generic_mask_t_frame4
    global generic_param_i_frame    	# Input program 
    global generic_param_i_frame2
    global generic_param_l_frame    	# layout grammar selected by the user
    global generic_param_l_frame3
    global generic_param_l_frame4
    global generic_param_o_frame        # output program	
    global generic_param_o_frame3
    global generic_param_o_frame4
    global generic_param_t_frame    	# transform program selected by user
    global generic_param_t_frame4
    global global_title		# title in ask_constraints window
    global global_contain	# containment constraint
    global global_position	# position constraint
    global global_quantity	# quantity contraint
    global gram_file 		# extension to input grammar files
    global grams 		# path to input grammar files
    global gram_file1 		# name of the skeleton grammar file
    global gram_file2 		# name of the skeleton grammar file
    global gou 			# name of windows to select output form

    global icdb_file 		# user defined index control file
    global icdb_mask 		# directory and mask for index control file
    global id 			# Process id, when editor is started 
 				#  (edit_structure.tcl)
    global index_file		# default extension to indexed document files
    global index_path   	# path to indexed document files	
    global index_mask           # path and mask to indeces
    global index_window 	# name of the indexing window
    global index_window_name 	# title of the indexing window
    global iprog_file 		# extension to input program files
    global iprogs 		# path to input program  files

    global LATEX_CMD            # directory and latex-command
    global layoutgram_file 	# extension to  layout grammar files
    global layouts 		# path to layout grammar files
    global lFile 		# tex-file
    global lpid 		# processid of the latex-process

    global m_ffile		# name of the filter file
    global m_ftype		# name of the filter type
    global match_window		# name of the filtering window 
    global match_window_name 	# title of the filtering window
    global matched_window	# name of the matched documents window 
    global matched_window_name 	# title of the matched documents window

    global newfilt_window       # name of the create-filter window
    global newfilt_window_name  # title of the create-filter window
    
    global of 			# name of the output frame
    global oldfilt_window       # name of the modify-old-filter window
    global oldfilt_window_name  # title of the modify-old-filter window
    global orig_annot		# original annoatation in filter
    global output_form 		# selected output form
    global ownfile		# .syndocdefaults-file

    global p_cmd 
    global params 		# list of the "keys" of the default values 
    global prev_file            # extension to preview files
    global prev_prog		# preview program defined by the user  
    global prevs  		# path to previewing files
    global printer		# Default printer 
    global print_cmd		# Default printer command 
    global prog_file 		# extension to  layout program files
    global progs 		# path to layout program files

    global ready 		# tk uses variable ready to wait
    global ready666		# tk uses variable ready to wait in filter def.
    global ret_window_name      # title of document-retrieval window
				 
    global rowNum 		# number of the current row in the text 
				# of the text widget
    global rulewin 		# name of the window for selecting rule
    global rw 			# name of document_retrieval window

    global selectedRule 	# return value (selected rule)
    global struct 		# path to skeleton grammar files
    global struct_file		# selected  skeleton grammar file 
    global sysfile 		# .syndocsysdefaults-file
    global s_file       	# system_command

    global tex_file 		# extension to  text files
    global texs 		# path to tex files
    global TMPHTML 		# temporary html file for previewing
    global transform_NewText    # content nonterminal for transformed document
    global transform_NewType    # document type for transformed document
    global transform_struct_file # structure grammar file for transformed doc. 
    global trgram_file 		# extension to  transformation grammar files
    global trgrams 		# path to transformation grammar files
    global trprog_file 		# extension to  transformation program files
    global trprogs 		# path to transformation program files
    global treehelp_file 	# name of the tree help file
    global tulos 		# result if prolog fails
    
    global w	 		# name of the toplevel window
    global win 			# name of the toplevel window
    global wp			# name of the latex preview window
    global wf 			# name of the frame in window in filter window
    global wf2			# name of window in  filter tree
    global wi 			# name of the window for indexing
    global wi2 

    set ownfile ~/.syndocdefaults;    	# users own default values 
    set sysfile $SYNDOCHOME/.syndocsysdefaults; # Systems default values

# List for "keys" in .syndocdefaults file
#   global SYNDOCWORK		# user's working directory
#   global STRUCTURE		# path and extension of skeleton grammars
#   global IGRAMMAR		# path and extension of input grammars
#   global IPROGRAM		# path and extension of input programs
#   global LGRAMMAR		# path and extension of layout grammars
#   global IPROGRAM		# path and extension of layout programs
#   global DOCUMENT		# path and extension of documents
#   global TGRAMMAR		# path and extension of transformation grammars
#   global TPROGRAM		# path and extension of transformation programs
#   global OUTPUT		# path and extension of formatted documents
#   global PRINTER		# default printer
#   global PRINTCMD		# default printer command
#   global EDITORCMD		# default editor command
#   global PREVPROG		# default preview program
#   global PREVFILE		# path and extension of formatted files to
				# be previewed
#   global CONTROL		# path and extension of control files
#   global INDEX		# path and extension of indexed documents
#   global FILTER		# path and extension of filter files



    set params { SYNDOCWORK STRUCTURE IGRAMMAR IPROGRAM LGRAMMAR \
		 LPROGRAM DOCUMENT TGRAMMAR TPROGRAM OUTPUT PRINTER \
		 PRINTCMD EDITORCMD PREVPROG PREVFILE \
		 CONTROL INDEX FILTER}












