# *******************************************************************
# syndochelp.tcl
#
# Function:   Creates a text widget and loads a helpfile.
# Date:       20.11.1995  
# Author:     Paula Leinonen                   
# **********************************************************************

#**************************************************************************
# Global variables - declarations in file  syndocglobals.tcl  
#**************************************************************************

# *******************************************************************
# Name:       open_help
# Input:      String (file)
#             String (calling window)
# Output:     -
# Function:   Creates a text widget and loads a helpfile.
# **********************************************************************
proc open_help {helpfile oldw} {
    global SYNDOCHOME
    set w .text
    catch {destroy $w}
    toplevel $w
    wm title $w "Help" 
    wm iconname $w "Help"
    dpos $w

    frame $w.buttons
    pack  $w.buttons -side bottom -expand y -fill x -pady 2m
    button $w.buttons.close -text Close -command "grab release $w
						   destroy $w
						   grab set $oldw"
    pack $w.buttons.close -side left -expand 1

    text $w.text -relief sunken -bd 2 -yscrollcommand "$w.scroll set" \
	-setgrid 1 \
	-height 30
    scrollbar $w.scroll -command "$w.text yview"
    pack $w.scroll -side right -fill y
    pack $w.text -expand yes -fill both

#    text_loadfile $w.text $helpfile
     set GLOBALHLP $SYNDOCHOME/syndoc.help
    text_loadfile $w.text $GLOBALHLP


    grab $w
}

# *******************************************************************
# Name:       text_loadfile 
# Input:      String (name of the text widget)
#             String (help file)
# Output:     -
# Function:   Loads the contents of the help file to the text widget.
# **********************************************************************
proc text_loadfile {w file} {
     if [file isfile $file] {
	 set f [open $file]
	 $w delete 1.0 end
	 while {![eof $f]} {
	     $w insert end [read $f 10000]
         }
	 close $f
     } else {
	 $w insert end "\"$file\" isn't a regular file!"
     }
}
