/*
 *-----------------------------------------------------------------------------
 * syndocretrieval.pl
 * User can index documents, define filters and search documents 
 * which match the filter and output them in required form
 *-----------------------------------------------------------------------------
*/
/*--------------------------------------------------------------------------
 *  filter_new generation 
 *--------------------------------------------------------------------------
*/

%Pred:filter_new(+Gram,+Filter,+Type)
filter_new(Gram,Filter,Type) :-
       setmarginals,
       % Tcl-procedure give_name(filename) returns the name of the file
       % without directorypath. Nimi kirjoitetaan filtterin alkuun
       % ilman polkua
        call_tcl(give_name(Filter)), 
	tcl_in(call_prolog(done(FilterName))),
        call_tcl(give_name(Gram)), 
	tcl_in(call_prolog(done(GramName))),
	% Tallatetaan filtteritiedoston nimi predikaatin 
	% filterFile_r arvoksi
	% ja kielioppi structureGram_r predikaatin arvoksi ja
	% tyyppi filterType_r predikaatin arvoksi
        % tarvitaan tallennuksen yhteydessa
	retractall(structureGram_r(_)),
        retractall(filterFile_r(_)),
        retractall(filterType_r(_)),
	assert(structureGram_r(GramName)),
        assert(filterFile_r(Filter)),
        assert(filterType_r(Type)),
        % tehdaan tyhja tiedosto filtterille Cancel toimintaa varten
        name(Filter,FilterChar),
        name(Type,TypeChar),
        append(FilterChar,".tmp",TmpChar),
        name(Tmp,TmpChar),
        tell(Tmp),
        told,
        % kielioppisaannot luettu kaynnistettaessa uuden filtterin
        % tekeminen, saannot on predikaateissa rule
        % kieliopin juuri predikaatissa nonTerm_r ja merkkijonovalike
        % predikaatissa smallestGramEl_r
        nonTerm_r(NonTerm),
        smallestGramEl_r(Text),!,
        % tehdaan otsikko ikkunaan, oltava "-merkkien valissa
        name(NonTerm,NonTermChar),
        name(FilterName,FilterNameChar),
        name('Filter: ',Title0),
        name('   Document type: ',Title1),
        name('   Filter type: ',Title3),
        append(Title0,FilterNameChar,Title00),
        append(Title00,Title1,Title01),
        append(Title01,NonTermChar,Title2),
        append(Title2,Title3,Title4),
        append(Title4,TypeChar,NonTermChar2),
        append([34|NonTermChar2],[34],NonTermChar1),
        name(NonTerm1,NonTermChar1),
        % lisataan juuren nimeen attribuutit ehtoja ja annotaatioita varten
        %attributeplaces are for constraints {;;} and annotations {}
        append(TypeChar,[123,59,59,125,123,125],TypeChar1),
        name(Type1,TypeChar1),
	Tree = Type1,!,
        assert(nonTerm(NonTerm)),
        assert(smallestGramEl(Text)),
	displayCurrentPlace([[[],Tree,[]],
             [[[],'*{;;}{}',[]],[[],'.{;;}{}',[]],[[],'document{;;}{}',[]]]],
	     TreeChar,_), %SelectionChar
        % tehdaan sarakkeiden otsikot
	addSpaces(TreeChar,TreeChar1),
        retractall(nonTerm(_)),
        retractall(smallestGramEl(_)),
	assert(currentFilter([[[],Tree,[]],
            [[[],'*{;;}{}',[]],[[],'.{;;}{}',[]],[[],'document{;;}{}',[]]]])), 
	    call_tcl(make_filtertree(TreeChar1, NonTerm1)),
            !.

%Pred:addSpaces
addSpaces(TreeChar,TreeChar1):-
        append([10,32],"RESULT",S2),
        struct(L1),
	% Otsikko TYPE siirretaan nuolen ohi (+2) ja tahden ohi
        % toiselle sisennystasolle
	    L2 is L1 - 7 + 2 + 6,
	setBetweenSpaces(L2,S3),
	append(S2,S3,S4),
        append(S4,"TYPE",S5),
        cons(L3), %contain marginaali
             L4 is L3 - L1 - 4 - 2 - 6,
	setBetweenSpaces(L4,S6),
	append(S5,S6,S7),
        append(S7,"CONTAINS",S8),
        conspos(L5), %position marginaali
             L6 is L5 - L3 - 7 - 1,
	setBetweenSpaces(L6,S10),
	append(S8,S10,S11),
        append(S11,"POSITION",S12),
        consqua(L7), %quantityn marginaali
             L8 is L7 - L5  - 8,
 	setBetweenSpaces(L8,S14),
	append(S12,S14,S15),
        append(S15,"QUANTITY",S16),
	     append(S16,[10,32],S17),
	append(S17,TreeChar,TreeChar1).
	    
%Pred:readGrammar_new
readGrammar_new(File) :-
	    % Luetaan rakennekielioppitiedostosta File dokumentin tyyppi ja 
            % tekstityyppi.
	    see(File),
	    read(Type),!,
	    read(Text),!,
	    % Dokumentin tyyppi talletetaan predikaatin nonterm_r_ arvoksi
	    % ja tekstityyppi predikaatin smallestGramEl_r.
	    retractall(nonTerm_r(_)),
	    retractall(smallestGramEl_r(_)),
	    assert(nonTerm_r(Type)),
	    assert(smallestGramEl_r(Text)),
	    % Tuhotaan vanhat kielioppisaannot tietokannasta.
	    retractall(rule(Type,_,_)),
	    % Luetaan uudet kielioppisaannot tietokantaan.
	    read_and_assertRules(Type),
	    seen.

%Pred:read_and_assert
           % Luetaan rakennekielioppisaannot predikaatin 
           % rule(Type,NonTerm,Rule) arvoksi  tietokantaan.
           % Type on dokumentin tyyppi.
           % NonTerm on kielioppisaannon vasemman puoleisin termi.
           % Rule on kielioppisaanto.
read_and_assertRules(Type) :-
	% Luetaan kielioppisaanto tiedostosta
	ruleInput(RuleChar),
	% Tarkistetaan, onko kaikki saannot jo luettu
        % endOfFile(End),
	(same(RuleChar,[end_of_file]);
          (same(RuleChar,[empty_line]);
	   word(RuleChar,NonTerm,_),   
	   name(Rule,RuleChar),
	   % Talletetaan kielioppisaanto tietokantaan.
	   assert(rule(Type,NonTerm,Rule))),
	   read_and_assertRules(Type)).


/*--------------------------------------------------------------------------
* filter_old generation
*--------------------------------------------------------------------------
*/

%Pred:filter_old
filter_old(Filter,Gram) :-
	setmarginals,
         % Tcl-procedure give_name(filename) returns the name of the file
         % without directorypath. Nimi kirjoitetaan filtterin alkuun
         % ilman polkua
        call_tcl(give_name(Filter)), 
	tcl_in(call_prolog(done(FilterName))),
        call_tcl(give_name(Gram)), 
	tcl_in(call_prolog(done(GramName))),
        % Talletetaan filtteritiedoston nimi predikaatin 
        % filterFile_r arvoksi
        % ja kielioppi structureGram_r predikaatin arvoksi
	 retractall(filterFile_r(_)),
	 retractall(structureGram_r(_)),
	 assert(filterFile_r(Filter)),
	 assert(structureGram_r(GramName)),
         % talletetaan filtteri Cancel toimintaa varten .tmp loppuiseen
         % tiedostoon
         name(Filter,FilterChar),
         append("cp ",FilterChar,CmdChar1),
         append(CmdChar1,[32|FilterChar],CmdChar2),
         append(CmdChar2,".tmp",CmdChar),
         name(Cmd,CmdChar),
         call_tcl(exec(Cmd)),
         %luetaan filtterista kielioppitiedoston nimi ja 
         % testataan onko se sama kuin annettu kielioppitiedosto
         see(Filter),
         read(StructGram),!, 
         % tarkistetaan etta rakennekieliopissa ja filtterissa 
         % sama kielioppi	
         check_grams(StructGram,GramName),
         %luetaan filtteritiedostosta kieliopin tyyppi, filtterin
         %  tekstivalike ja filtterin tyyppi
	 % Kieliopin tyyppi talletetaan predikaatin nonTerm_r arvoksi
	 % ja tekstityyppi predikaatin smallestGramEl_r.
	 read(NonTerm), 	 
	 read(Text), 
	 retractall(nonTerm_r(_)),
	 retractall(smallestGramEl_r(_)),
	 assert(nonTerm_r(NonTerm)),
	 assert(smallestGramEl_r(Text)),
         %talletetaan filtterin tyyppi filterType_r predikaattiin
         read(FiltType),	 
         retractall(filterType_r(_)),
         assert(filterType_r(FiltType)),	 
         % saannot luettu kielioppitiedostosta, 
         % ennen filtterin lukua tarkistetaan etta
         %tehdaan otsikko ikkunaan
         name(FilterName,FilterNameChar),
         name(NonTerm,NonTermChar), 
         name(FiltType,FiltTypeChar),
         name('Filter: ',Title0),
         name('    Document type: ',Title1),
         name('    Filter type: ',Title3),
         append(Title0,FilterNameChar,Title11),
         append(Title11,Title1,Title01),
         append(Title01,NonTermChar,Title2),
         append(Title2,Title3,Title4),
         append(Title4,FiltTypeChar,NonTermChar1),
         append([34|NonTermChar1],[34],NonTermChar2),
         name(NonTerm2,NonTermChar2),
         %luetaan filtteri
	 read(Tree),
	 seen,
         assert(nonTerm(NonTerm)),
         assert(smallestGramEl(Text)),
	 same([[[],Tree,[]],[[[],'document{;;}{}',[]]]],CurrentPlace),
         % siirrytaan ensimmaiseen filtterin juureen 	
	 exeCmd(low,CurrentPlace,CurrentPlace1), 	 
	 exeCmd(low,CurrentPlace1,NewCurrentPlace), 	 
	 displayCurrentPlace(NewCurrentPlace,TreeChar,_), %SelectionChar
         % lisataan otsikot  
	 addSpaces(TreeChar,TreeChar1),
         retractall(nonTerm(_)),
         retractall(smallestGramEl(_)),
	 assert(currentFilter(NewCurrentPlace)),
         call_tcl(make_filtertree(TreeChar1,NonTerm2)).
/*
*-----------------------------------------------------------------------------
* filter_tree
*-----------------------------------------------------------------------------
 * - Tulostetaan filtteri naytolle.
 * - Toiminnoilla zoom, unzoom, addfilter, delfilter muokataan jasennyspuuta.
 * - Toiminnoilla constraints, annotations lisataan ehtoja solmuihin
 * - Toiminnoilla child, parent,left,right, down, up liikutaan jasennyspuussa.
 * - Toiminnolla save talletetaan puu.
 * - Toiminnolla save_exit talletetaan puu ja poistutaan edelliseen valikkoon.
 * - Toiminnolla cancel poistutaan edelliseen valikkoon ilman tallennusta.
 * - Predikaatin currentTree arvona on sen hetkinen jasennuspuu.

*/
%Pred:filter_zoom
filter_zoom:-
            currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(zoom,CurrentPlace,NewCurrentPlace), 	
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (findplainStar(SelectionChar,_),
	        B1 is 1, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1	
             ;
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
       	     retract(currentFilter(CurrentPlace)), 	
	     assert(currentFilter(NewCurrentPlace)), 	
	  call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).

%Pred:filter_unzoom
filter_unzoom:-
	    currentFilter(CurrentPlace), 	
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(unzoomcurrent,CurrentPlace,NewCurrentPlace), 	
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	   addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1, 	 
	    (findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1 	
            ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
            retract(currentFilter(CurrentPlace)), 	
	    assert(currentFilter(NewCurrentPlace)), 	
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).

%Pred:filter_addfilter
filter_addfilter:-
            currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(addfilter,CurrentPlace,NewCurrentPlace2),
            exeCmd(low,NewCurrentPlace2,NewCurrentPlace),
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1
              ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
       	     retract(currentFilter(CurrentPlace)), 	
	     assert(currentFilter(NewCurrentPlace)), 	
	     call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).

%Pred:filter_delfilter
filter_delfilter:-
	    currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    % Suoritetaan toiminto del.
	    exeCmd(del,CurrentPlace,NewCurrentPlace),
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1 	
            ;
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
	    retract(currentFilter(CurrentPlace)),
	    assert(currentFilter(NewCurrentPlace)),
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).

%Pred:filter_constraints
filter_constraints:-
            currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(constraints,CurrentPlace,NewCurrentPlace), 	
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1 	
            ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
       	     retract(currentFilter(CurrentPlace)), 	
	     assert(currentFilter(NewCurrentPlace)), 	
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).

%Pred:filter_annotations
filter_annotations:-
            currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(annotations,CurrentPlace,NewCurrentPlace), 	
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1 	
            ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
       	     retract(currentFilter(CurrentPlace)), 	
	     assert(currentFilter(NewCurrentPlace)), 	
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).
    

%Pred:filter_parent
filter_parent:- 
            currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(up_r,CurrentPlace,NewCurrentPlace),
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1 	
            ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
	    retract(currentFilter(CurrentPlace)),
	    assert(currentFilter(NewCurrentPlace)),
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).

%Pred:filter_child
filter_child:-
            currentFilter(CurrentPlace), 	 
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(low_r,CurrentPlace,NewCurrentPlace), 	 
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),  
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1 	
            ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
 	    retract(currentFilter(CurrentPlace)),
 	    assert(currentFilter(NewCurrentPlace)),
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).

%Pred:filter_right
filter_right:-
            currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(right,CurrentPlace,NewCurrentPlace),
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (			
	    findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1 	
            ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
	    retract(currentFilter(CurrentPlace)),
	    assert(currentFilter(NewCurrentPlace)),	
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).

%Pred:filter_left
filter_left:-
	    currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(left,CurrentPlace,NewCurrentPlace),
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (			
	    findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1 	
            ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
	    retract(currentFilter(CurrentPlace)),
	    assert(currentFilter(NewCurrentPlace)),
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).


%Pred:filter_down
filter_down:-
            currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(downscreen,CurrentPlace,NewCurrentPlace),
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (			
	    findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is  1 	
            ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
	    retract(currentFilter(CurrentPlace)),
	    assert(currentFilter(NewCurrentPlace)),	
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).


%Pred:filter_up
filter_up:-
	    currentFilter(CurrentPlace),
            nonTerm_r(NonTerm),
            smallestGramEl_r(Text),
            asserta(nonTerm(NonTerm)),
            asserta(smallestGramEl(Text)),
	    exeCmd(upscreen_r,CurrentPlace,NewCurrentPlace),
	    displayCurrentPlace(NewCurrentPlace,TreeChar,SelectionChar),
	    addSpaces(TreeChar,TreeChar1),
            countLines(TreeChar,0,N),N1 is N + 1,
	    (			
	    findplainStar(SelectionChar,_),
	        B1 is 0, B8 is 0, B10 is 1, 
		B11 is 0, B12 is 0, B14 is 1 	
            ; 			
 	     B1 is 1, B8 is 1,B10 is 0, 
	     B11 is 1, B12 is 1, B14 is 0),
             retractall(nonTerm(NonTerm)),
             retractall(smallestGramEl(Text)),
	    retract(currentFilter(CurrentPlace)),
	    assert(currentFilter(NewCurrentPlace)),
	    call_tcl(insert_filter(TreeChar1,B1,B8,B10,B11,B12,B14,N1)).


%Pred:filter_save
filter_save:-
            currentFilter(CurrentPlace),
            rewindToRoot_r(CurrentPlace,[[_,NewTree,_],_]),
            structureGram_r(Gram),
	    filterFile_r(Filt),
	    smallestGramEl_r(Text),
	    nonTerm_r(NonTerm),
            filterType_r(Type),
	    tell(Filt),
	    writeq(Gram),write('.'),nl,
	    writeq(NonTerm),write('.'),nl,
	    writeq(Text),write('.'),nl,
	    writeq(Type),write('.'),nl,
	    writeq(NewTree),write('.'),nl,
	    nl,
	    write_filters(NewTree),
	    told.


%Jarjestetaan jasennyspuu talletettavaan muotoon, retrieval-osassa
%Pred:rewindToRoot_r
rewindToRoot_r(CurrentPlace,AtRoot):-
	(same(CurrentPlace,[[[],Tree,[]],[[[],'document{;;}{}',[]]]]),!,
	 same([[[],Tree,[]],[[[],'document{;;}{}',[]]]],AtRoot);
	 up_r_save(CurrentPlace,NewCurrentPlace),!,
         rewindToRoot_r(NewCurrentPlace,AtRoot)).




%Pred:filter_save_exit
filter_save_exit:-
	    currentFilter(CurrentPlace),
            rewindToRoot_r(CurrentPlace,[[_,NewTree,_],_]),
            structureGram_r(Gram),
	    filterFile_r(Filt),
	    smallestGramEl_r(Text),
	    nonTerm_r(NonTerm),
            filterType_r(Type),
	    tell(Filt),
	    writeq(Gram),write('.'),nl,
	    writeq(NonTerm),write('.'),nl,
	    writeq(Text),write('.'),nl,
	    writeq(Type),write('.'),nl,
	    writeq(NewTree),write('.'),nl,
	    nl,
	    write_filters(NewTree),
	    told,
            % tuhotaan Filt.tmp tiedosto
            name(Filt,FiltChar),
            append("rm ",FiltChar,RmChar1),
            append(RmChar1,".tmp",RmChar),
            name(RmCmd,RmChar),
            call_tcl(exec(RmCmd)),
            cleanup_filter.

%Pred:filter_cancel
filter_cancel:-
            filterFile_r(Filt),
            % palautetaan filtteri valiaikaisesta tiedostosta
            name(Filt,FiltChar),
            append("cp ",FiltChar,CmdChar1),
            append(CmdChar1,".tmp ",CmdChar2),
            append(CmdChar2,FiltChar,CmdChar),
            name(Cmd,CmdChar),
            unix(system(Cmd)),
            % tuhotaan Filt.tmp tiedosto
            unix(system(Cmd)), 
            append("rm ",FiltChar,RmChar1),
            append(RmChar1,".tmp",RmChar),
            name(RmCmd,RmChar),
            call_tcl(exec(RmCmd)),
            cleanup_filter.


cleanup_filter:-
	    retractall(currentFilter(_)),
	    retractall(filterType_r(_)),
	    retractall(filterFile_r(_)),
            retractall(structureGram_r(_)),
            retractall(smallestGramEl_r(_)),
            retractall(nonTerm_r(_)),
            retractall(cons(_)),
            asserta(cons(44)),		%constraintin marginaali
            retractall(struct(_)),
            asserta(struct(14)),		%rakenteen marginaali
            retractall(conspos(_)),
            asserta(conspos(60)),          %position marginaali
            retractall(consqua(_)),
            asserta(consqua(70)).         %quatityn marginaali


%Pred:write_filters
write_filters(Tree) :-
	% Kirjoitetaan yhdistetyn filterin filtterit kukin omalle rivilleen.
	% Otetaan  piste eli juuri pois
	Tree =.. [Root|ListOfSubtrees],
	name(Root,RootList),
	% Tarkistetaan, etta kyseessa on filtteri
	(same(".{;;}{}",RootList),
	write_filter(ListOfSubtrees);
%	true).
        write(Tree),write('.'),nl). 

%Pred:write_filter
write_filter([FilterRoot|RestFilters]):-
	(notempty(FilterRoot),
	    % Tahti pois filtterin alusta
	    FilterRoot =.. [_|CleanFilter],
	    % Tyhjia filttereita ei kirjoiteta
	    (notempty(CleanFilter),
		(append([],[VeryCleanFilter|_],CleanFilter),
		write(VeryCleanFilter),
		write('.'),nl,nl);
	    true), 
	    write_filter(RestFilters);
	true).


%Pred:remove_cons_ann
remove_cons_ann([],[]):-!.
remove_cons_ann([123|_],[]):-!.
remove_cons_ann([C|RootConsAnnChar],[C|RootChar]):-
	remove_cons_ann(RootConsAnnChar,RootChar).	
	
%Pred:make_rules_for_subtrees
make_rules_for_subtrees([]).
make_rules_for_subtrees([First|RestOfSubtrees]):-
	First =.. [Root|ListOfFirstTree],
	name(Root,[Point]),period(Point),
	make_rules_for_subtrees(ListOfFirstTree),
	make_rules_for_subtrees(RestOfSubtrees).
make_rules_for_subtrees([First|RestOfSubtrees]):-
	First =.. [Root|ListOfFirstTree],
	make_rule(Root,ListOfFirstTree),
	make_rules_for_subtrees(ListOfFirstTree),
	make_rules_for_subtrees(RestOfSubtrees).
	

%Pred:define_right_side
define_right_side([],[_,St|RS],RS) :-straight(St),!.
define_right_side([],RS,RS) :-!.
define_right_side([Subtree|RestOfSubtrees],RightSide,RightSide3):-
	Subtree =.. [Root|ListOfSubTrees],
	name(Root,[Point]),
	period(Point),
	flatten(ListOfSubTrees,ListOfSubTrees1),
	define_right_side(ListOfSubTrees1,RightSide,RightSide2),
	define_right_side(RestOfSubtrees,RightSide2,RightSide3).
define_right_side([Subtree|ListOfSubtrees],RightSide,RightSide3):-
	Subtree =.. [Root|_],
	% erotetaan attribuutit
	separateConstraintAndAnnotation(Root,RootChar,ConsChar,AnnChar),
	(findStraight(RootChar,RootChar1),
	 append(RightSide,[32,124,32|RootChar1],RightSide1);
	append(RightSide,[32|RootChar],RightSide1)),
        addCorrectAttributes(RightSide1,ConsChar,AnnChar,RightSide2),    
	define_right_side(ListOfSubtrees,RightSide2,RightSide3).

%Pred:addCorrectAttributes
addCorrectAttributes(RightSide1Char,ConsChar,AnnChar,RightSide2Char):-
	empty(ConsChar),empty(AnnChar),
	same(RightSide1Char,RightSide2Char).

addCorrectAttributes(RightSide1Char,ConsChar,AnnChar,RightSide2Char):-
	empty(ConsChar),notempty(AnnChar),	
	append(RightSide1Char,[91|AnnChar],S1),
	 append(S1,[93],RightSide2Char).	
addCorrectAttributes(RightSide1Char,ConsChar,AnnChar,RightSide2Char):-
	notempty(ConsChar),empty(AnnChar),
	 append(RightSide1Char,[123|ConsChar],S1),
	 	append(S1,[125],RightSide2Char).
addCorrectAttributes(RightSide1Char,ConsChar,AnnChar,RightSide2Char):-
	notempty(ConsChar),notempty(AnnChar),     
	 append(RightSide1Char,[123|ConsChar],S1),
 	 append(S1,[125,91|AnnChar],S2),
	 append(S2,[93],RightSide2Char).	



/*********** commands ***************/

% Kehitetaan atomia.
% Haetaan tietokannasta atomia vastaava kielioppisaanto.
% Jos yksi, liitetaan saannon oikean puolen atomi puuhun.
% Jos useita vaihtoehtoja liitetaan kaikkien oikeiden puolien atomit listana
% puuhun, vaihtoehtoisten atomien nimen eteen pannaan |
%Pred:zoom
zoom([[LS,Root,RS],Context],[[[],First,SisterAtomList],
                                 [[LS,Root,RS]|Context]]):-
	atom(Root),
	name(Root,S1),
	% Valinnaisen solmun ymparilta poistetaan hakasulut.
	(findBracket(S1,S2),name(Root1,S2);
        % listan lopusta otetaan tahti tai plus pois
        findStarPlus(S1,S3),name(Root1,S3);
        %valinnaisen alusta otetaan pois | ja lopusta attribuutit
        findStraight(S1,S4),
	findLBrace(S4,S5),name(Root1,S5);
	% nimesta pitaa ottaa pois attribuuttien arvot
        findLBrace(S1,S6),name(Root1,S6)),
	% Tietokannasta haetaan oikea kielioppisaanto tai oikeat saannot.
	!,getSelectedAtoms(Root1,[First|SisterAtomList]),!.

% poistetaan kursorin osoittaman solmun sisaret puusta, juuresta tulee atomi
%Pred:unzoom
unzoom([_,[T1|Context]],[T1,Context]):- !.

% solmun lasten poisto
%Pred:unzoomcurrent
unzoomcurrent([[R,T,L],Context],[[R,T1,L],Context]):-
           (atom(T),same(T,T1);
            T=..[Root|_],
            same(Root,T1)).


%lisataan filtteri atomiin filter, filtteri haetaan tiedostosta ja
% lisataan alipuuna tai luodaan juurinonterminaali
%Pred:addfilter
addfilter([[Tleft,FilterTree1,Tright],Context],[[Tleft,FilterTree,Tright1],Context]):-
	%atom(FilterRoot),
%avaa ikkuna jolla kysytaan tiedoston nimi ja luetaan filtteri tai 
%juuriterminaali
        % readFilter(FilterSubTree),
        % FilterTree =.. [FilterRoot,FilterSubTree].
         readFilter(FilterSubTree),
	 (same(FilterSubTree,cancel),
	 same(FilterTree1,FilterTree),
	 same(Tright,Tright1)
	 ;
         (atom(FilterSubTree),
          FilterTree=..['*{;;}{}',FilterSubTree],
          append([FilterTree1],Tright,Tright1)
          ;
         FilterSubTree=..[_,FilterTree|RestTrees],
         append(RestTrees,[FilterTree1],FilterTree2),
         append(FilterTree2,Tright,Tright1)
          )).


%Pred:readFilter
readFilter(FilterSubTree):-
	% ikkunan otsikko "Add simple filter to the compound filter"
         % TR300596, lisatty palautus
         call_tcl(ask_filter('*.filt','*')),
	 tcl_in(call_prolog(done(FilterFile,NonT))),
	 (same(FilterFile,cancel),
	 same(FilterSubTree,cancel)
	 ;
        %palauttaa FilterFile tai * ja  * tai NonT
        name(FilterFile,FilterFileChar),
        (member(42,FilterFileChar), % tahti=42 ei ole muutettu tiedostonimea 
        % luodaan nonterminaali
        name(NonT,NonTChar),
        addConstraintAndAnnotation(NonTChar,FilterSubTree,[],[])
        ;
        %haetaan tiedostosta
	see(FilterFile),
	read(Gram), %filtterin  kielioppitiedostonnimi,
        % vertaa
	structureGram_r(StructGram),same(Gram,StructGram),
	read(Type), %filtterin kieliopin lahtosymboli, 
        %vertaa
	nonTerm_r(FiltType),same(Type,FiltType),
	read(SmallestGramEl), %kieliopin tekstisymboli,
        %vertaa (itext)
	smallestGramEl_r(FiltSmallestGramEl),
	same(SmallestGramEl,FiltSmallestGramEl),
	read(_), %filtterin lahtosymboli
	read(FilterSubTree), %filtteripuu 
	seen)).


% Liikutaan puussa solmun isa-solmuun.
% Tassa tapauksessa ollaan jo juuri solmussa.
%Pred:up_r
up_r([[[],R,[]],[[[],'document{;;}{}',[]]]],[[[],R,[]],[[[],'document{;;}{}',[]]]]):-
       call_tcl(open_msg("Already in the root ! ")),
       tcl_in(call_prolog(ok)),
       !.
% Tassakin tapauksessa ollaan jo juuri solmussa.
up_r([[A,R,T],[[[],'.{;;}{}',[]],[[],'document{;;}{}',[]]]],[[A,R,T],[[[],'.{;;}{}',[]],[[],'document{;;}{}',[]]]]):-
       call_tcl(open_msg("Already in the root ! ")),
       tcl_in(call_prolog(ok)),
       !.
% Liikutaan puussa solmun isa-solmuun.
up_r([[Tl,Tc,Tr],[[LS,R,RS]|Context]],[[LS,T,RS],Context]):-
        reverse(Tl,TlRev),
	checkislist([Tc|Tr],Ts),
	append(TlRev,Ts,Tsub),
	checklist_r(Tsub,Tsub1),
	T=..[R|Tsub1].


% Liikutaan puussa solmun isa-solmuun.
% Tassa tapauksessa ollaan jo juuri solmussa.
%Pred:up_r_save
up_r_save([[[],R,[]],[[[],'document{;;}{}',[]]]],[[[],R,[]],[[[],'document{;;}{}',[]]]]):-
       call_tcl(open_msg("Already in the root ! ")),
       tcl_in(call_prolog(ok)),
       !.
% Liikutaan puussa solmun isa-solmuun.
up_r_save([[Tl,Tc,Tr],[[LS,R,RS]|Context]],[[LS,T,RS],Context]):-
        reverse(Tl,TlRev),
	checkislist([Tc|Tr],Ts),
	append(TlRev,Ts,Tsub),
	checklist_r(Tsub,Tsub1),
	T=..[R|Tsub1].


% Liikutaan naytossa ylempaan elementtiin.
% jos ollaan ensimmaisen juuressa, ei menna mihinkaan
%Pred:upscreen_r 
upscreen_r([[[],R,T],[[[],'.{;;}{}',[]],[[],'document{;;}{}',[]]]],
                    [[[],R,T],[[[],'.{;;}{}',[]],[[],'document{;;}{}',[]]]]).
% jos ollaan jo tarpeeksi vasemmalla, ensimmaisessa lapsessa
 % siirrytaan isaan, joka on naytossa ensimmaisen lapsen 
 % ylapuolella 
upscreen_r([[[],T1,Tright],Context],NewCurrentPlace):-
        up_r([[[],T1,Tright],Context],NewCurrentPlace).
% jos ollaan muussa lapsessa, sen ylapuolelle on joko atominen
 % vasen sisar 
upscreen_r([[[T1|Tleft],T2,Tright],Context],
      [[Tleft,T1,[T2|Tright]],Context]):-
       atom(T1).
 % tai vasemman sisaren puun  ensimmainen lehti  esijarjestyksessa
upscreen_r([[[T1|Tleft],T2,Tright],Context],NewCurrentPlace):-
       left([[[T1|Tleft],T2,Tright],Context],NewCurrentPlace1),
       previousInSequence(NewCurrentPlace1,NewCurrentPlace).


% Kaytetaan predikaatissa up_r.
% Muodostetaan samaan *- ja +-rakenteeseen kuuluvista solmuista lista.
% Nain muodostetaan sisakkaisia listarakenteita, kun liikutaan ylemmalle
% tasolle puussa.
%Pred:checklist_r
checklist_r([],[]):-!.
checklist_r([X|RestOfTsub],Tsub1):-
	X =..[Root|_],
	separateConstraintAndAnnotation(Root,RootChar,_,_),
	append(RootChar,[42],S2),
	name(Root1,S2),
        append(RootChar,[43],S22),
	name(Root2,S22),!,
	((checkListEnd(Root1,RestOfTsub),same(Root1,Root3);
          checkListEnd(Root2,RestOfTsub),same(Root2,Root3)),
	 assert(restoflist(RestOfTsub)),
	 makeList_r(RestOfTsub,Root3,Xs),
	 restoflist(TsubRest),
	 checklist_r(TsubRest,Tsub2),
	 append([[X|Xs]],Tsub2,Tsub1)
	;
	 checklist_r(RestOfTsub,Tsub2),
	 append([X],Tsub2,Tsub1)
	;
	 true).

%Pred:checkListEnd
checkListEnd(_,[]):-!,fail.
checkListEnd(Root,[R|Rs]):-
	R=..[RRoot|_],
	separateConstraintAndAnnotation(RRoot,RChar,_,_),!,
	name(Rplain,RChar),
	(same(Root,Rplain);
	checkListEnd(Root,Rs)).

%Pred:makeList_r
makeList_r([X|Xs],Root1,List):-
	X =..[XRoot|_],
	separateConstraintAndAnnotation(XRoot,XRootChar,_,_),!,
	name(Xplain,XRootChar),
	(same(Xplain,Root1),same([],List1),
	retractall(restoflist(_)),assert(restoflist(Xs))
	;
	 makeList_r(Xs,Root1,List1)),
	 append([X],List1,List).


 % siirrytaan puussa alaspain.
 % puussa Tree on rakenne valmiina, puussa vain yksi alipuu
 % tutkitaan onko se tekstityyppipuu, jolloin ei tehda mitaan
 % muussa tapauksessa siirrytaan puun juureen, jos se 
 % lista latistetaan, jolloin siirrytaan 1. listan alkioon
%Pred:low_r
low_r([[LS,Tree,RS],Context],[[LS1,Tree1,RS1],Context1]):-
        Tree =..[Root,T],
	T =.. [First,_],!,
	smallestGramEl_r(Element),
	(same(First,Element),!,
	 same(Tree,Tree1),
	 same(Context,Context1),same(LS,LS1),same(RS,RS1)
         ;
	  notempty(T),
      	 (is_list(T),flatten(T,[Tree1|RS1]),same([],LS1);
	  same(T,Tree1),same([],LS1),same([],RS1)),
	 same([[LS,Root,RS]|Context],Context1)).
% puussa Tree on kaksi tai useampia alipuita, jolloin siirrytaan 1. alipuun
% juureen.
% jos se on lista, latistetaan ja siirrytaan 1. lista-alkioon
% muussa tapauksessa siita tulee uusi puu, tutkitaan
% onko oikeat sisaret lista (jos ei otetaan sellaisenaan
% muuten  poistetaan ylimaaraiset listasulut)
low_r([[LS,Tree,RS],Context],[[[],T,Tright],[[LS,Root,RS]|Context]]):-
	(Tree=..[Root,T1|Tright1],
	 (is_list(T1),flatten([T1|Tright1],[T|Tright]);
	  same(T1,T),(is_list(Tright1),flatten(Tright1,Tright);
		      same(Tright1,[Tright])))
         ;
	 Tree=..[Root|T1],
          notempty(T1),
 	 (is_list(T1),flatten(T1,[T|Tright]);
	  same(T1,T),same(Tright,[]))).


% Asetetaan kehitetylle puulle juuri{arvo}{arvo1}(alipuut) constraint 
% pitaa tulla juuri{uusiarvo}{arvo1}(alipuut)
%Pred:contraints
constraints([[LS,Tree,RS],Context],[[LS,Tree1,RS],Context]):-
	Tree=..[Root|Tr],
	%otetaan attribuuttimerkinnat pois nonterminaalin Root perasta
	separateConstraintAndAnnotation(Root,RootChar,ConstraintChar,
                 AnnotationChar),
        %erotellaan ehdot
        separateCons(ConstraintChar,ContainChar,PositionChar,QuantityChar),
	% Avataan aksconstraints-ikkuna (editor-ikkuna).
	% Valinnaisen solmun ymparilta poistetaan hakasulut.
	(findBracket(RootChar,NonTermChar);
        % listan lopusta otetaan tahti tai plus pois
        findStarPlus(RootChar,NonTermChar);
        %valinnaisen alusta otetaan pois |
        findStraight(RootChar,NonTermChar);
	%muussa tapauksessa nimi kelpaa
	same(RootChar,NonTermChar)),
        name(NonTerm,NonTermChar),
        % talletetaan vanhat ehto-arvot
	assert(containCons_old(ContainChar)),
        assert(positionCons_old(PositionChar)),
        assert(quantityCons_old(QuantityChar)),
        ((member(43,RootChar);member(42,RootChar)),
        %avataan ikkuna joka kysyy ehdon
         % ikkunoita on kahdenlaisia: 
         % jos kasiteltavassa solmussa on
       % * tai + niin silloin kysytaan kaikki ehdot: contain, position,
       % quantity
        call_tcl(ask_constraints(NonTerm,ContainChar,PositionChar,
                         QuantityChar)),
	 tcl_in(call_prolog(done(NewContainChar,NewPositionChar,
                         NewQuantityChar))),       
         % Palauttaa NewContainChar, NewPositionChar, NewQuantityChar 	
	assert(containCons(NewContainChar)),
        assert(positionCons(NewPositionChar)),
        assert(quantityCons(NewQuantityChar))
        ;
        % jos kasiteltavassa solmussa ei ole 
        % * tai + niin silloin kysytaan  ehdot: contain, position
        call_tcl(ask_constraints1(NonTerm,ContainChar,
                            PositionChar)),
	 tcl_in(call_prolog(done(NewContainChar,NewPositionChar))),
	assert(containCons(NewContainChar)),
        assert(positionCons(NewPositionChar)),
        same(QuantityChar,NewQuantityChar),
        assert(quantityCons(NewQuantityChar))
         ),
         (same(NewContainChar,"cancel"),
	  same(Tree,Tree1),!
	 ;
         % Palauttaa NewContainChar, NewPositionChar, NewQuantityChar 	
         % Tarkistetaan onko annotaatioita ja assertoidaan ne
	currentFilter(TreeAndSisters),
	checkAnnotations(TreeAndSisters),
	% Tarkastetaan, ovatko nonterminaalit saavutettavia  
	append(NewContainChar,[32],ConstraintList),
	checkConstraints(ConstraintList,RootChar,[],Errors2Char),
	(empty(Errors2Char),
	    % constraintit virheettomia
	    (append(RootChar,[123|NewContainChar],Root2Char),
	    append(Root2Char,[59|NewPositionChar],Root22Char),
	    append(Root22Char,[59|NewQuantityChar],Root222Char),
	    append(Root222Char,[125,123|AnnotationChar],Root3Char),
	    append(Root3Char,[125],Root1Char),
	    name(Root1,Root1Char),
	    Tree1 =.. [Root1|Tr],
            retract(containCons(NewContainChar)),
            (retract(positionCons(NewPositionChar));true),
            (retract(quantityCons(NewQuantityChar));true),
	    retractall(annotation(_)))
            ;
            % constraintissa virhe
            retract(containCons(NewContainChar)),
            (retract(positionCons(NewPositionChar));true),
            (retract(quantityCons(NewQuantityChar));true),
            %avataan ikkuna nonterminals jossa ilmoitetaan mitka 
            % nonterminaalit
            % eivat ole saavutettavissa, Ikkunassa otsikkona Root1 ja
            % Errors2Char
            name(Root1,RootChar),
              call_tcl(nonterminals(RootChar,Errors2Char)),
                   tcl_in(call_prolog(ok)),
	    	editConstraints(NonTerm,NewContainChar,NewPositionChar,
                                    NewQuantityChar,RootChar,
	    	                     AnnotationChar,Tr,Tree2),
           % cancel palauttaa Tree2:n arvona 'cancel', muuten
           % Tree2:n arvona on uudet ehdot sisaltava puu
                (same(Tree2,cancel),
                    same(Tree,Tree1);
                    same(Tree2,Tree1)),
            % poistetaan assertoidut annotaatiot
		retractall(annotation(_)))).

%Pred:editConstraints
editConstraints(NonTerm,ContainChar,PositionChar,QuantityChar,
                     RootChar,AnnotationChar,Tr,Tree1):-
        (
        (member(43,RootChar);member(42,RootChar)),
        call_tcl(ask_constraints(NonTerm,ContainChar,PositionChar,
                         QuantityChar)),
	 tcl_in(call_prolog(done(NewContainChar,NewPositionChar,
                         NewQuantityChar))),      
         % Palauttaa NewContainChar, NewPositionChar, NewQuantityChar 	
	assert(containCons(NewContainChar)),
        assert(positionCons(NewPositionChar)),
        assert(quantityCons(NewQuantityChar))
        ;
        % jos kasiteltavassa solmussa ei ole 
        % * tai + niin silloin kysytaan  ehdot: contain, position
        call_tcl(ask_constraints1(NonTerm,ContainChar,
                            PositionChar)),
	 tcl_in(call_prolog(done(NewContainChar,NewPositionChar))),
	assert(containCons(NewContainChar)),
        assert(positionCons(NewPositionChar)),
        same(QuantityChar,NewQuantityChar),
        assert(quantityCons(NewQuantityChar))
        ),
         (same(NewContainChar,"cancel"),
          same(Tree1,cancel),!
	 ;
	% Annetut merkkijonot predikaateissa containCons, positionCons,
        % quantityCons.
	% Tarkastetaan, ovatko nonterminaalit saavutettavia 
	append(NewContainChar,[32],ConstraintList),
	checkConstraints(ConstraintList,RootChar,[],Errors2Char),
	(empty(Errors2Char),
	    % constraintit virheettomia
	    (append(RootChar,[123|NewContainChar],Root2Char),
	    append(Root2Char,[59|NewPositionChar],Root22Char),
	    append(Root22Char,[59|NewQuantityChar],Root222Char),
	    append(Root222Char,[125,123|AnnotationChar],Root3Char),
	    append(Root3Char,[125],Root1Char),
	    name(Root1,Root1Char),
	    Tree1 =.. [Root1|Tr],
            retract(containCons(NewContainChar)),
            (retract(positionCons(NewPositionChar));true),
            (retract(quantityCons(NewQuantityChar));true),
	    retractall(annotation(_)))
            ;
            % constraintissa virhe
            retract(containCons(NewContainChar)),
            (retract(positionCons(NewPositionChar));true),
            (retract(quantityCons(NewQuantityChar));true),
%avataan ikkuna nonterminals jossa ilmoitetaan mitka nonterminaalit
% eivat ole saavutettavissa, Ikkunassa otsikkona RootChar ja Teksti Text3
            name(Root1,RootChar),
             call_tcl(nonterminals(RootChar,Errors2Char)),
                   tcl_in(call_prolog(ok)),
	    	editConstraints(NonTerm,NewContainChar,NewPositionChar,
                                    NewQuantityChar,RootChar,
	    	                    AnnotationChar,Tr,Tree1),
		retractall(annotation(_))
          )).


%Pred:checkContraints
checkConstraints([],_,Errors,Errors):-!.
checkConstraints([32],_,Errors,Errors):-!.
checkConstraints([C|ConsList],RuleRoot,Errors,Errors2):-
	% Ohitetaan ei-nonterminaalit eli lainausmerkeissa olevat 
	(double_quote(C),
	    (append(_,[34|RestCons],ConsList),
	    checkConstraints(RestCons,RuleRoot,Errors,Errors2));
	    (letter(C),
		(append(NonTerm,[32|RestCons],[C|ConsList]),
		name(NonTerm2,NonTerm),
		% Valinnaisen solmun ymparilta poistetaan hakasulut.
		(findBracket(RuleRoot,RuleRoot2);
        	% listan lopusta otetaan tahti tai plus pois
        	findStarPlus(RuleRoot,RuleRoot2);
        	%valinnaisen alusta otetaan pois |
        	findStraight(RuleRoot,RuleRoot2);
		%muussa tapauksessa nimi kelpaa
		same(RuleRoot,RuleRoot2)),
		name(RuleRoot3,RuleRoot2),
		% etsitaan saannot, joista nonterminaali voidaan saavuttaa
		searchRules_r(RuleRoot3,ListOfRulesForRoot),
		% tutkitaan saavutettavuus 
		((checkReachability(NonTerm2,RuleRoot3,ListOfRulesForRoot),
		    checkConstraints(RestCons,RuleRoot,Errors,Errors2);
		    % tarkistetaan onko saavuttamaton nonterminaali annotaatio
		    (annotation(NonTerm),
		    	checkConstraints(RestCons,RuleRoot,Errors,Errors2);
		    	% loytyi saavuttamaton nonterminaali, lisataan virhelistaan
		    	(append(NonTerm,[32],NonTerm3),
		    	append(Errors,NonTerm3,Errors3),
		    	checkConstraints(RestCons,RuleRoot,Errors3,Errors4),
		    	append(Errors4,[],Errors2))))));
		% ohitetaan merkki, joka ei ole kirjain
		checkConstraints(ConsList,RuleRoot,Errors,Errors2))).

% TR220896: searchNonterminals is now a prolog-prolog only procedure,
% use tcl_searchNonterminals from tcl.
%Pred: tcl_searchNonterminals
tcl_searchNonterminals:-
            (
	      nonTerm_r(Root),
              findall(NonTerm,(C=..[rule,Root,NonTerm,_],call(C)),ListOfTypes),
              listToChar_c(ListOfTypes,[],Selected,0,_), 
              call_tcl(give_list(Selected))
	    ;
	    
	      %TR220896. vaikka homma epaonnistuisi, pitaa palauttaa jotain.
              call_tcl(give_list(32))
	    ).


%Pred:checkReachability
checkReachability(NonTerm,NonTerm,_):-!.
checkReachability(_,_,[]):-
	!,fail.
checkReachability(NonTerm,Root,[Rule|[]]):-
	% ohitetaan saannon vasen puoli ja nuoli
	name(Rule,RuleChar),
	word_r(RuleChar,Word,RestRuleChar),
	same(Root,Word),
	word_r(RestRuleChar,Arrow,RestRuleChar1),
	same(Arrow,'->'),  
	word_r(RestRuleChar1,FirstSubtr1,RestRuleChar2),
	name(FirstSubtr1,FirstSubtree1),
	% Valinnaisen solmun ymparilta poistetaan hakasulut.
	(findBracket(FirstSubtree1,FirstSubtree2);
        % listan lopusta otetaan tahti tai plus pois
        findStarPlus(FirstSubtree1,FirstSubtree2);
        %valinnaisen alusta otetaan pois |
        findStraight(FirstSubtree1,FirstSubtree2);
	%muussa tapauksessa nimi kelpaa
	same(FirstSubtree1,FirstSubtree2)),
	name(FirstSubtree3,FirstSubtree2),
	searchRules_r(FirstSubtree3,ListOfRulesForRoot),!,
	(notempty(ListOfRulesForRoot),
	checkReachability(NonTerm,FirstSubtree3,ListOfRulesForRoot)
	;
	check_rest(NonTerm,RestRuleChar2)).
checkReachability(NonTerm,Root,[Rule|RestRules]):- 
	(checkReachability(NonTerm,Root,[Rule]),
	!;
	checkReachability(NonTerm,Root,RestRules)).

%Pred:check_rest
check_rest(_,[]):-
	!,fail.
check_rest(NonTerminal,P):- 
	word_r(P,W,P1),
	name(W,W1),
	% Valinnaisen solmun ymparilta poistetaan hakasulut.
	(findBracket(W1,W3);
        % listan lopusta otetaan tahti tai plus pois
        findStarPlus(W1,W3);
        %valinnaisen alusta otetaan pois |
        findStraight(W1,W3);
	%muussa tapauksessa nimi kelpaa
	same(W1,W3)),
	name(W4,W3),
	searchRules_r(W4,ListOfRulesForRoot),!,
	(notempty(ListOfRulesForRoot),
	checkReachability(NonTerminal,W4,ListOfRulesForRoot)
	;
	check_rest(NonTerminal,P1)).

%Pred:separateContraintAndAnnotation
separateConstraintAndAnnotation(Root,Root1Char,ConstraintChar,AnnotationChar):-
	name(Root,RootChar),word_r(RootChar,Nonterminal,[C|RestChar]),
	name(Nonterminal,Root1Char),
	lbrace(C),word_r([C|RestChar],Constraint,[C1|Rest1Char]),
	name(Constraint,ConstraintChar),
	lbrace(C1),word_r([C1|Rest1Char],Annotation,_),
	name(Annotation,AnnotationChar).

%Pred:addConstraintAndAnnotation
addConstraintAndAnnotation(RootChar,Root,ConstraintChar,AnnotationChar):-
	append(RootChar,[123|ConstraintChar],Root1Char),
	append(Root1Char,[125,123|AnnotationChar],Root2Char),
	append(Root2Char,[125],Root3Char),
	name(Root,Root3Char).

% Asetetaan kehitetylle puulle juuri{arvo}{arvo1}(alipuut) constraint 
% pitaa tulla juuri{uusiarvo}{uusiarvo1}(alipuut)
%Pred:annotations
annotations([[LS,Tree,RS],Context],[[LS,Tree1,RS],Context]):-
	Tree=..[Root|Tr], 
	%otetaan attribuuttimerkinnat pois nonterminaalin Root perasta
	separateConstraintAndAnnotation(Root,RootChar,ConstraintChar,AnnotationChar),
	% Avataan annotation-ikkuna.
	% tehdaan ensin ikkunan otsikko Annotation for Nonterminal
	% Valinnaisen solmun ymparilta poistetaan hakasulut.
	(findBracket(RootChar,TitleChar);
        % listan lopusta otetaan tahti tai plus pois
        findStarPlus(RootChar,TitleChar);
        %valinnaisen alusta otetaan pois |
        findStraight(RootChar,TitleChar);
	%muussa tapauksessa nimi kelpaa
	same(RootChar,TitleChar)),
	name('Annotation for ',BeginChar),
	append(BeginChar,TitleChar,TitleChar1),
%avataan ikkuna joka kysyy annotaation
        call_tcl(ask_annotation(TitleChar1,AnnotationChar)),
	tcl_in(call_prolog(done(NewAnnotationChar))),
%palauttaa NeWAnnotationChar
	% Annettu merkkijono predikaatissa annoCons.
        checkExistance(NewAnnotationChar,NewAnnotationChar1),
	append(RootChar,[123|ConstraintChar],Root2Char),
	append(Root2Char,[125,123|NewAnnotationChar1],Root3Char),
	append(Root3Char,[125],Root1Char),
	name(Root1,Root1Char),
	Tree1 =.. [Root1|Tr].

%Pred:checkExistance
checkExistance(AnnoChar,AnnoChar1):-
         name(Anno,AnnoChar),
         (rule(_,Anno,_),
       call_tcl(open_msg("Name is one of the names of text types in the grammar!")),
       tcl_in(call_prolog(ok)),
          same("",AnnoChar1)
         ;
         same(AnnoChar,AnnoChar1)).
          



checkAnnotations([TreeAndSisters,Context]):-
	% Asetetaan yksi tyhja annotaatio, jotta annotation vertailu ei kaadu
	assert(annotation([])),
	% Ensin kaydaan lapi jasennyspuun osoitettu-osa (pointed-part).
	checkTreeAndSisters(TreeAndSisters),
	% ja sitten konteksti.
	checkContext(Context).


% Jasennyspuun konteksti-osa.
checkContext([]).
checkContext([[[],'document',[]]]).
checkContext([[[],'document{;;}{}',[]]]).
checkContext([Level|RestLevels]):-
	% Kontekstia kaydaan lapi taso kerrallaan.
        checkTreeAndSisters(Level),
	checkContext(RestLevels).


checkTreeAndSisters([[],Root,[]]) :-
	% vain atominen juuri, ei sisarpuita, tarkistetaan etta on atomi
	atom(Root),!,name(Root,RootChar),
	% erotetaan attribuutit nimen perasta
	(member(123,RootChar),
	(separateConstraintAndAnnotation(Root,RootChar1,_,Anno),
	assertAnnotation(Anno));
	same(RootChar,RootChar1)).



checkTreeAndSisters([[],Tree,[]]):-
	% puu, ei sisarpuita
	% Poistetaan sisakkaiset listat
	checkislist(Tree,Tree1),
	% on puu, erotetaan juuri
	Tree1 =..[Root|Children],!,
	(name(Root,[RootChar]),
	%puu on lista, jonka juuri on piste
	isPoint(RootChar),
	% ensimmainen lapsi valitaan
	selectFirstChild(Children,RootChar1),
        flatten(Children,Children1),
	checkChildren(Children1)
	;
	name(Root,RootChar),
	%puu 
	% erotetaan constraint ja annotation
	(member(123,RootChar),
	(separateConstraintAndAnnotation(Root,RootChar1,_,Anno),
	assertAnnotation(Anno));
	same(RootChar,RootChar1)),
	% Lasten kirjoitus .
	checkChildren(Children)).

checkTreeAndSisters([LS,Tree,RS]):-
	% Puu tai atomi, jolla on sisarpuita
	!,
	checkislist(Tree,Tree1),
	% Solmu ja sen alipuut.
	checkTreeAndSisters([[],Tree1,[]]),!,
	% Solmun vasemmat sisaret.
	checkLeftSisters(LS),!,
	% Solmun oikeat sisaret.
        checkRightSisters(RS),!.

% Kaydaan lapi solmun vasemmat sisaret.
checkLeftSisters([]):-!.
checkLeftSisters([L|Ls]):-!,
	checkLeftSisters(Ls),
	checkTreeAndSisters([[],L,[]]).

% Kaydaan lapi solmun oikeat sisaret.
checkRightSisters([]):-!.
checkRightSisters([R|Rs]):-
        checkTreeAndSisters([[],R,[]]),!,
	checkRightSisters(Rs).


checkChildren([]) :- !.
checkChildren([FirstSister|RestOfSisters]) :-
	atom(FirstSister),!,
	% atomi
	name(FirstSister,FirstSisterChar),
	(member(123,FirstSisterChar),
	% erotetaan attribuutit nimen perasta
	separateConstraintAndAnnotation(FirstSister,_,_,Anno),
	assertAnnotation(Anno),
	checkChildren(RestOfSisters)).

checkChildren([FirstSister|RestOfSisters]) :-
	% Alipuu on lista
	 FirstSister =..[RootFirst|[RestFirst]],
	      % sisar, joka on text ja sen lapsena merkkijono
	      % text-sisar on aina ainoa lapsi
	     (smallestGramEl_r(Element),
	      % Tutkittavan puun juuri on tekstielementti.
	      same(RootFirst,Element),!
	      ;
	      % Tarkistetaan, onko puun listaesityksessa pisteita.
	      name(RootFirst,[Point]),
	      isPoint(Point),
	      % Tarkistetaan, onko sisakkaisia listoja.
	      checkislist(RestFirst,RestFirst1),
	      checkChildren(RestFirst1),
	      checkChildren(RestOfSisters)
	      ;
	      % sisar, joka ei ole text
	      name(RootFirst,RootFirstChar),
	      % erotetaan attribuutit nimen perasta
	      (member(123,RootFirstChar),
	       (separateConstraintAndAnnotation(RootFirst,RootFirstChar1,_,Anno),
	       assertAnnotation(Anno));
	       same(RootFirstChar,RootFirstChar1)),
	      checkislist(RestFirst,RestFirst1),
	      checkChildren([RestFirst1]),
	      checkChildren(RestOfSisters)).

checkChildren([FirstSister|RestOfSisters]) :-
	  % Alipuu ei ole lista
	  FirstSister =..[RootFirst|RestFirst],
	      % sisar, joka on text ja sen lapsena merkkijono
	      % text-sisar on aina ainoa lapsi
	     (smallestGramEl_r(Element),
	      % Tutkittavan puun juuri on tekstielementti.
	      same(RootFirst,Element),!
	      ;
	      % Tarkistetaan, onko puun listaesityksessa pisteita.
	      name(RootFirst,[Point]),
	      isPoint(Point),
	      % Tarkistetaan, onko sisakkaisia listoja.
	      checkislist(RestFirst,RestFirst1),
	      checkChildren(RestFirst1),
	      checkChildren(RestOfSisters)
	      ;
	      % sisar, joka ei ole text
	      name(RootFirst,RootFirstChar),
	      % erotetaan attribuutit nimen perasta
	      (member(123,RootFirstChar),
	      (separateConstraintAndAnnotation(RootFirst,RootFirstChar1,_,Anno),
	       assertAnnotation(Anno));
	       same(RootFirstChar,RootFirstChar1)),
	      checkislist(RestFirst,RestFirst1),
	      checkChildren(RestFirst1),
	      checkChildren(RestOfSisters)).

assertAnnotation([]) :- !.
assertAnnotation(Annotation) :- assert(annotation(Annotation)).


/*
 *----------------------------------------------------------------------------
 *   read structure from the grammar in retrieval
 *---------------------------------------------------------------------------
*/
%Pred:getSelectedAtoms
getSelectedAtoms(Root,ListOfAtomsForRoot):-
        searchRules_r(Root,ListOfRulesForRoot),
	count(ListOfRulesForRoot,NumberOfRules),
        (NumberOfRules > 1,
	      addAlternativeMark(Root,ListOfRulesForRoot,ListOfAtomsForRoot)
        ;
	NumberOfRules = 1,
		listToOneRule(ListOfRulesForRoot,Rule),
                genSubtrees_r(Root,Rule,ListOfAtomsForRoot)	      
        ;
	NumberOfRules < 1,
      call_tcl(open_msg("No rule in the structure grammar for this element!")),
       tcl_in(call_prolog(ok))),
	!.


% Etsitaan solmua vastaavat kielioppisaannot tietokannasta.
%Pred:searchRules
searchRules_r(Root, List) :-
	nonTerm_r(DocType),
	findall(R, (C =..[rule,DocType,Root,R],call(C)), List).


%Pred:listToOneRule
listToOneRule([Rule],Rule).

%Pred:addAlternativeMark
addAlternativeMark(_,[],[]):-!.
addAlternativeMark(Root,[R|Rs],[Ar|Ars]):-
	genAtomsAndAddMark(Root,R,[Ar]),
         addAlternativeMark(Root,Rs,Ars).
        
  	

% Kielioppisaannon muodosta paa->vartalo erotetaan vartalon atomit. 
% vartalon atomien eteen kirjoitetaan |.
%Pred:genAtomsAndAddMark
genAtomsAndAddMark(Root,Rule,[FirstAtom|RestAtoms]):-
	name(Rule,RuleChar),
	word_r(RuleChar,Word,RestRuleChar),
	same(Root,Word),
	word_r(RestRuleChar,Arrow,RestRuleChar1),
	same(Arrow,'->'),  
	word_ro(RestRuleChar1,FirstAtom1,RestRuleChar2),
        addAttributes(FirstAtom1,FirstAtom),
	restrule_ro(_,RestRuleChar2,RestAtoms).

%Pred:restrule_ro
restrule_ro(_,[],[]):-!.
restrule_ro(_,P,[W1|Ws]):- word_ro(P,W11,P1),
	addAttributes(W11,W1),!,restrule_ro(_,P1,Ws).


% Kielioppisaannon muodosta paa->vartalo erotetaan vartalon atomit. 
%Pred:genSubtrees_r
genSubtrees_r(Root,Rule,[FirstSubtree|RestSubtrees]):-
	name(Rule,RuleChar),
	word_r(RuleChar,Word,RestRuleChar),
	same(Root,Word),
	word_r(RestRuleChar,Arrow,RestRuleChar1),
	same(Arrow,'->'),  
	word_r(RestRuleChar1,FirstSubtree1,RestRuleChar2),
	addAttributes(FirstSubtree1,FirstSubtree),
	restrule_r(_,RestRuleChar2,RestSubtrees).

% Lisataan atomiseen nonterminaaliin paikat constraint ja
%annotation attribuuteille, {;;} ja {} nimen peraan
%Pred:addAttributes
addAttributes(Nonterminal,AttributedNonterminal):-
	name(Nonterminal,NonterminalChar),
	append(NonterminalChar,[123,59,59,125,123,125],
                                  AttributedNonterminalChar),
	name(AttributedNonterminal,AttributedNonterminalChar).

%Pred:restrule_r
restrule_r(_,[],[]):-!.
restrule_r(_,P,[W2|Ws]):- word_r(P,W1,P1),
	addAttributes(W1,W2),
	!,restrule_r(_,P1,Ws).


%Pred:word_r(+CharacterList,-Token,-RestCharacterList)
% Erotetaan sana (merkkijono seuraavaan valimerkkiin) ASCIImerkkijonosta
% retrieval-osassa 
% Muuttujan A arvona on sana atomisesa muodossa.
% Muuttujan P1 arvona on loppuosa merkkijonosta.
% Sana sisaltaa isoja tai pienia kirjamia, alaviivan, ja ?- merkin.
word_r([C|P],A,P1):-
	letter(C),rest_atom(P,Cs,[P2|P1],letter_or_),
        question_mark(P2),
        append([C|Cs],[P2],P3),
	uc_to_lc(P3,L),name(A,L).
% Sana sisaltaa isoja tai pienia kirjamia, alaviivan, tahden tai
% plus-merkin.               
word_r([C|P],A,P1):-
	letter(C),rest_atom(P,Cs,P1,letter_or_star_or_plus),
	uc_to_lc([C|Cs],L),name(A,L).
% Sana on  merkit ->.
word_r([C,C2|Cs],'->',Cs):-
	hyphen(C),greater_than(C2),!.
% Sana sisaltaa vasemman sulun, mita tahansa merkkeja, oikean sulun,
% *-merkin tai +-merkin. Kasittelyssa ei ole eroa + ja * listoille
word_r([C|P],A,P1):-
	left_parenthesis(C),!,rest_atom(P,Cs,[P2,P3|P4],any_but_right_parenthesis),
	right_parenthesis(P2),
	(single_star(P3);single_plus(P3)),
	append(Cs,[P3],P5),name(A,P5),
	same(P4,P1).
% Sana sisaltaa vasemman hakasulun, mita tahansa merkkeja,
% oikean hakasulun.
word_r([C|P],A,P1):-
	left_bracket(C),!,rest_atom(P,Cs,[P2|P1],any_but_right_bracket),
       	right_bracket(P2),
	append([C],Cs,P5),
	append(P5,[P2],P6),
	name(A,P6).
% Sana sisaltaa vasemman aaltosulun, mita tahansa merkkeja,
% oikean aaltosulun.
word_r([C|P],A,P1):-
	lbrace(C),!,rest_atom(P,Cs,[P2|P1],any_but_rbrace),
       	rbrace(P2),!,
	name(A,Cs).
% Sana sisaltaa vasemman hakasulun sijasta ? ja mita tahansa merkkeja,
% (retrieval-merkinta optional-alkiolle
word_r([C|P],A,P1):-
	question_mark(C),!,rest_atom(P,Cs,P1,letter_or_),
	append([C],Cs,P5),
	name(A,P5).
% Sana sisaltaa viivan ja  mita tahansa merkkeja paitsi vasen aaltosulku.
word_r([C|P],A,P1):-
	straight(C),!,rest_atom(P,Cs,P1,any_but_lbrace),!,
	name(A,[C|Cs]).
% Sana sisaltaa tahden
word_r([C|P],A,P1):-
	single_star(C),!,rest_atom(P,Cs,P1,any_but_lbrace),
	name(A,[C|Cs]).
% Sana sisaltaa pisteen
 word_r([C|P],A,P1):-
        period(C),!,rest_atom(P,_,P1,any_but_lbrace),!,
        name(A,[32]).
% Sana sisaltaa vain kaksoislainausmerkin.
% word_r([C|P],'empty',P):-double_quote(C),!.
% Sanan ensimmainen merkki on jokin muu kuin kirjain, lainausmerkki,
% valiviiva, vasen sulku, vasen hakasulku, vasen aaltosulku, kysymysmerkki,
% pystyviiva, tahti, piste, kaksoislainausmerkki.
word_r([_|P1],W,P2):-word_r(P1,W,P2).
% Sana on tyhja.
word_r([],'',[]) :- !.



% Tutkitaan merkkijonon sisaltoa retrieval-osassa
% kielioppisaannon nonterminaaleille, joihin on lisattava eteen |.
% Muuttujan A arvona on se osa merkkijonosta, joka on kayty lapi.
% Muuttujan P1 arvona on loppuosa merkkijonosta.
%

% Merkkijono sisaltaa isoja tai pienia kirjamia, alaviivan, tahden tai
% plus-merkin.               
%Pred:word_ro
word_ro([C|P],A,P1):-
	letter(C),!,rest_atom(P,Cs,P1,letter_or_star_or_plus),
	uc_to_lc([124,C|Cs],L),name(A,L).

% Merkkijono sisaltaa vasemman sulun, mita tahansa merkkeja, oikean sulun,
% *-merkin tai +-merkin.
word_ro([C|P],A,P1):-
	left_parenthesis(C),!,rest_atom(P,Cs,[P2,P3|P4],any_but_right_parenthesis),!,
	right_parenthesis(P2),
	(single_star(P3);single_plus(P3)),
	append([124|Cs],[P3],P5),name(A,P5),
	same(P4,P1).

% Merkkijono sisaltaa vasemman hakasulun, mita tahansa merkkeja,
% oikean hakasulun.
word_ro([C|P],A,P1):-
	left_bracket(C),!,rest_atom(P,Cs,[124,P2|P1],any_but_right_bracket),!,
       	right_bracket(P2),
	append([C],Cs,P5),
	append(P5,[P2],P6),
	name(A,P6).



% Merkkijonon ensimmainen merkki on jokin muu kuin kirjain, lainausmerkki,
% viiva, vasen sulku, vasen hakasulku.
word_ro([_|P1],W,P2):-word_ro(P1,W,P2).
% Merkkijono on tyhja.
word_ro([],'',[]) :- !.





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Match
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%Pred:tcl_consultLayoutProg(StructureGram,Prog):-
tcl_consultLayoutProg(StructureGram,Prog):-
            (call_tcl(give_name(StructureGram)),
            tcl_in(call_prolog(done(Sname))),
            see(Prog), 
	    %TR230896
	    read(_),   
                read(PrStructureGram),
		check_grams(Sname,PrStructureGram),
            seen,
            oconsult(Prog)
            ;
            call_tcl(prolog_fail(1))),
            call_tcl(prolog_done).

%TR220896, kun tama funktio epaonnistuu
% yhteys prologiin katkeaa.
%Pred:tcl_layoutDocument
tcl_layoutDocument(Doc,DocOut) :-
	    (layoutDocument(Doc,DocOut)
	     ;
	     
	      %TR230896: layout failed, hopefully all files have been closed.
	      call_tcl(prolog_fail(1))
            ),
	    call_tcl(prolog_done).

%Pred:layoutDocument
layoutDocument(Doc,DocOut) :-
            see(Doc),
              read(_),
              read(NonTerm),!,
              read(_),
              read(Tree),
            seen,!,
            Goal =..[NonTerm,Tree,_,_],
            tell(DocOut),
	    %TR230896
            (
	      call(Goal)
	      ;
	        % IMPORTANT!
		% File MUST be closed in every possible case!
	        told,
		% Return failure to caller
		!,fail
	    ),
            told.




%Pred:tcl_consultTransformProg(StructureGram,Prog):-
tcl_consultTransformProg(StructureGram,Prog):-
            (call_tcl(give_name(StructureGram)),
            tcl_in(call_prolog(done(Sname))),
            see(Prog), 
	    %TR230896
	    read(_),   
                read(PrStructureGram),
		check_grams(Sname,PrStructureGram),
               read(NewStructureGram),
               read(NewType),
               read(NewText),
            seen,
            oconsult(Prog),
    call_tcl(set_tcl_variable(transform_struct_file,NewStructureGram)),
    call_tcl(set_tcl_variable(transform_NewType,NewType)),
    call_tcl(set_tcl_variable(transform_NewText,NewText))
            ;
            call_tcl(prolog_fail(1))),
            call_tcl(prolog_done).

%Pred:tcl_transformDocument
%TR230896: MUST close all files on error
tcl_transformDocument(Doc,DocTrans,NewGram,NewType,NewText) :-
	    (
	     (
	      transformDocument(Doc,DocTrans,NewGram,NewType,NewText)
	     );
             call_tcl(prolog_fail(1))
	    ),
	    call_tcl(prolog_done).

%Pred:transformDocument
transformDocument(Doc,DocTrans,NewGram,NewType,NewText) :-
	    see(Doc),!,
	    read(_),
	      read(Type),
	      read(_),
	      read(Tree),
	    seen,!,
	    Goal =..[Type,Tree,NewTree,_,_],
	    call(Goal),!,
	    tell(DocTrans),!,
	     writeq(NewGram),write('.'),nl,
	      writeq(NewType),write('.'),nl,
	      writeq(NewText),write('.'),nl,
	      writeq(NewTree),write('.'),nl,
	    told.





